#include <stdio.h>
#include <math.h>                          // each model has 2 err, err2 ignore
#define  nn    9999                         // UBAND SLONG data
double aa[nn],dd[nn];                      
double rc,dc,a_c,d_c,up_a,dn_a,up_d,dn_d,ddc,e12;
double hs,cx,cy,w_de,hs2,pi,cosdc;
short  mx[nn],my[nn];
float  ee[nn],err[nn],me[nn],mrr[nn];      // psf,err,model,err
int    u3index[471][360],no[nn],no2[nn],n;       
short  griz[nn][21];                       // u_ext,g_psf,err,g_mod,err,g_ext...
float  zz[nn];
int    maxj,nk;
float  fg[21];
FILE   *fp;
// new default match_err is 1.0
// real in makecat.c,  using 1e-7, 3600/sqrt(1e-7)=1.13842" 

main(int ac,char **av)
{
  double hw_de,hw_al,xa,xd,z;
  char   ch,cc,c0,c1[14],c2[14],dis[215];
  int    i,j,k,k1,k2;
  if(ac<3){ printf("\n\t**** INDEX psf_a73_star in 2'*2' area *****");
            printf("\n\t\t\t             jiang 20130223\n");
            printf("\n\t\tUsage: sla731 ra dec [!,#,1.0]\n");
                                        // [$ % ! # 1.0] for myself
            printf("\n\t\tEx: sla73 21:13:47.590 01:52:38.13");
            printf("\n\t\t    sla73 21:13:47.590 01:52:38.13 #");
            printf("\n\t\t    sla73 23:02:57.551 -02:34:50.63 6.0");
            printf("\n\t\t    sla73 23.04932 -2.58073 !\n");
            printf("\n\t\t!   means display all");
            printf("\n\t\t#   simple model");
            printf("\n\t\t1.0 set match range (0.5-10.0, default 1.0\")\n");
            printf("\n\t\toutput with *, means matched\n\n");
            exit(0);
  } 
  pi=4.*atan(1.); cx=pi/12.; cy=pi/180.;
  fp=fopen("/DR973/dr973.unf","rb");
  if(fp==0){ printf("\n\t usl_data should put to /DR973\n"); exit(0); }
  fread(u3index,360*441,4,fp); fclose(fp);
  strcpy(dis,av[1]); strcat(dis," "); strcat(dis,av[2]);
  j=0; for(i=0;i<strlen(dis);i++)if(dis[i]==':')j=1;
  if(j==0){ sscanf(dis,"%lf",&rc); sscanf(av[2],"%lf",&dc); }
  else itohd(dis,&rc,&dc,&z);
  w_de=2.;
  while(rc>24.)rc-=24.;     while(rc<0.)rc+=24.;
  ddc=dc; if(dc>85.)dc=85.;  if(dc<-25.25)dc=-25.25;
  hw_de=w_de/120.;
  up_d=dc+hw_de;    dn_d=dc-hw_de; 
  xa=cos(up_d*cy);  xd=cos(dn_d*cy);  z=xa; if(z>xd)z=xd;
  hw_al=hw_de/z/15.;  if(hw_al>12.)hw_al=12.;
  up_a=rc+hw_al;      if(up_a>=24.)up_a-=24.;
  dn_a=rc-hw_al;      if(dn_a<  0.)dn_a+=24.;
  hs=hw_de*cy;   hs2=255./hs;
  a_c=rc*cx;     d_c=dc*cy;
  cosdc=cos(d_c); if(cosdc<.05)cosdc=.05;
  n=0;
  k1=(dn_d+25.25)*4.;  k2=(up_d+25.25)*4.+0.9999;
  if(k1<0)k1=0; if(k2>440)k2=440;
  for(i=k1;i<k2;i++)cat_u3(i);      // n+++
  toms2(rc,c1,1); toms2(ddc,c2,0);

  ch=0; z=1.0;
  if(ac>3) ch=av[3][0]; 
  if(ch>=48 && ch<=57)sscanf(av[3],"%lf",&z); 
  if(z<0.5)z=0.5; if(z>10.)z=10.;  
  e12=z/3600.; e12=e12*e12;

  if(ch!='%' && ch!='$' && ch!='#' && ch!='!')ch=0;
  if(ch!='%') printf("#center: %s %s (2000.0) Field: 2*2' usl:%4d",c1,c2,n);
  if(n==0){ printf("\n"); exit(0); } 

  sortd4(no,no2,aa,dd,ee,err,me,mrr,mx,my,griz,n);

  for(i=nk=0;i<n;i++){   zz[i]=99.;
    xa=(rc-aa[i])*cosdc*15.; xd=dc-dd[i]; z=xa*xa+xd*xd; 
    if(z<e12){ nk++; zz[i]=z; } 
  }
  maxj=-1; z=99.;
  for(i=0;i<n;i++){
    if(zz[i]==99.)continue;
    if(zz[i]<z){ maxj=i; z=zz[i]; }
    zz[i]=sqrt(zz[i])*3600.;
  }            

  if(ch=='$'){ z=0.; if(nk)z=ee[maxj]; printf("%9.3lf\n",z); exit(0); }
  if(ch=='%'){
    i=maxj;
    toms2(aa[i],c1,1);  toms2(dd[i],c2,0);
    cc='g'; j=no2[i]; if(j<0){ cc='s'; j=-j; }
    sprintf(dis,"%5.2f%s %s %010d%09d %6.3f%6.3f %6.3f%6.3f %c",
            zz[maxj],c1,c2,no[i],j,ee[i],err[i],me[i],mrr[i],cc);
    for(j=0;j<21;j++)fg[j]=griz[i][j]*0.001;
    k=79;
    for(j=0;j<21;j++){
      sprintf(&dis[j*6+k],"%6.3f ",fg[j]);
      if(j%5==0 || j%5==2)k++;
    } 
    printf("%s\n",dis);
    exit(0);
  }

  if(ch=='!'){
    printf("\n#"); for(i=0;i<52;i++)printf("-"); 
    printf("   u_psf  3551a u_a73   ty ");
    if(ac>3){printf("u_ext    g_psf  4686  g_a73     ");
             printf("g_ext    r_psf  6166  r_a73     ");
             printf("r_ext    i_psf  7480  i_a73     ");
             printf("i_ext    z_psf  8932  z_a73     z_ext"); }  
    for(i=0;i<n;i++){
      toms2(aa[i],c1,1);  toms2(dd[i],c2,0);
      cc='g'; j=no2[i]; if(j<0){ cc='s'; j=-j; }
      c0=32; if(zz[i]<99.)c0=42;
      sprintf(dis,"%c%4d%s %s %010d%09d %6.3f%6.3f %6.3f%6.3f %c",c0,
  		   i+1,c1,c2,no[i],j,ee[i],err[i],me[i],mrr[i],cc);
      for(j=0;j<21;j++)fg[j]=griz[i][j]*0.001;
      k=79;
      for(j=0;j<21;j++){ sprintf(&dis[j*6+k],"%6.3f ",fg[j]);
        if(j%5==0 || j%5==2)k++;
      } 
      printf("%s\n",dis);
    }
    exit(0);
  }
// ch=0,#
  printf("  match: %d\n",nk);
  if(nk==0 && ch=='#')exit(0);
  printf("#"); for(j=0;j<52;j++)printf("-"); 
  printf("   u_psf  3551a u_a73   ty");
  if(nk)printf(" match_err\n"); else printf("\n");
  for(i=0;i<n;i++){
    if(zz[i]<99.)c0=42; else c0=32;
    toms2(aa[i],c1,1);  toms2(dd[i],c2,0);
    cc='g'; j=no2[i];   if(j<0){ cc='s'; j=-j; }
    if(ch=='#' && c0==32)continue;
    printf("%c%4d%s %s %010d%09d %6.3f%6.3f %6.3f%6.3f %c",
          c0,i+1,c1,c2,no[i],j,ee[i],err[i],me[i],mrr[i],cc);
    if(c0==32)printf("\n"); 
    else printf("%5.2f\"\n",zz[i]);
  }
}

i_star(ra,dc,ix,iy)
double ra,dc; short *ix,*iy;
{
  double xa,xd,xi,xn;
  xa=ra*cx; xd=dc*cy;
  standc(a_c,d_c,xa,xd,&xi,&xn);
  *ix=hs2*(hs-xi)+.5;
  *iy=hs2*(xn-hs)+510.5;
  if(*ix < 0 || *ix >510)return(0);
  if(*iy < 0 || *iy >510)return(0);
  return(1);
}

struct { int i1,i2; double ra,dc; short ugriz[25]; } u;
cat_u3(i360)
int i360;
{
  double x1,x2, ra,dc,xa,xd,xmag;
  short  ix,iy;
  char   f1[30], c1[14],c2[14];
  int    i,j,k;

  i=i360;
  x1=dn_a; x2=up_a;  if(x2<x1)x2+=24.;
  j=x1*15.; j--; if(j<0)k=0; else  k=u3index[i][j];
  if(i360<101)sprintf(f1,"/DR973/s%02d%c\0",(100-i)/4,((100-i)%4)+97);
  else        sprintf(f1,"/DR973/n%02d%c\0",(i-101)/4,((i-101)%4)+97);

  fp=fopen(f1,"rb");
  if(fp==0)return;
l05:
  fseek(fp,k*74,0);
l10:
  fread(&u,1,74,fp);   if(feof(fp))goto l20;
  k++;
  ra=u.ra/15.;
  if(ra>x2)goto l100;               // normal exit
  if(ra<x1)goto l10;
  dc=u.dc;    if(dc<dn_d || dc>up_d)goto l10;
  xmag=u.ugriz[0]*0.001; 
  if(i_star(ra,dc,&ix,&iy)){
    no[n]=u.i1;
    no2[n]=u.i2;
    aa[n]=ra;
    dd[n]=dc;
    ee[n] =xmag;
    err[n]=u.ugriz[1]*0.001;
    me[n] =u.ugriz[2]*0.001;
    mrr[n]=u.ugriz[3]*0.001;
    mx[n]=ix;
    my[n]=iy;
    for(i=0;i<21;i++)griz[n][i]=u.ugriz[i+4];
    n++; if(n==nn)n--;
  }
  goto l10;
l20:
  x1-=24.; x2-=24.;  k=0;
  goto l05;
l100:
  fclose(fp);
}

toms2(aa,c,k)
double aa;           // input
char c[14];          // output
int k;               // input
{
  int  i,j;
  double a,b,x;
  a=aa;
  if(k==1){ if(a>24.)a-=24.; if(a<0.)a+=24.; }
  c[0]=32; if(a<0.){ a=-a; c[0]='-'; }
  i=a; b=(a-i)*60.;
  j=b; x=(b-j)*60.;
  if(j==60){ j=0; i++; }
  if(k==1)sprintf(&c[1],"%2.2d:%2.2d:%6.3f",i,j,x);
  if(k==0)sprintf(&c[1],"%2.2d:%2.2d:%5.2f",i,j,x);
  if(c[7]==32)c[7]='0';   if(c[8]==32)c[8]='0';
  if(c[7]=='6'){
    c[7]='0'; j++; sprintf(&c[4],"%2.2d",j);
    if(c[4]=='6'){
      c[4]='0'; i++; sprintf(&c[1],"%2.2d",i);
    }
    c[3]=':'; c[6]=':';
  }
}

standc(rc,dc,ra,de,xi,xn)
double rc,dc,ra,de,*xi,*xn;
{
  double sd,cd,td,co,tmp;
  sd=sin(dc);
  cd=cos(dc);
  td=tan(de);
  co=cos(ra-rc);
  tmp=sd*td+cd*co;
  *xi=sin(ra-rc)/tmp;
  *xn=(cd*td-sd*co)/tmp;
}

itohd(a,rc,dc,epoch)
char *a; double *rc,*dc,*epoch;
{
  int i,j,k;
  int i1,i2,g1,g2,g3,p;
  double x3;
  char b[70];
  strcpy(b,a);
  i1=i2=g1=g2=g3=p=0;
  *rc=*dc=*epoch=0.;
  k=strlen(a);
  for(i=0;i<k;i++)if(b[i]<=',')b[i]=32; //allowed comma and below
  for(i=0;i<k;i++)if(b[i]!=32)break;
  if(i!=k)g1=i; else goto l10;
  for(j=g1;j<k;j++)if(b[j]==32)break;
  for(i=j;i<k;i++)if(b[i]!=32)break;
  if(i!=k)g2=i; else goto l10;
  for(j=g2;j<k;j++)if(b[j]==32)break;
  for(i=j;i<k;i++)if(b[i]!=32)break;
  if(i!=k)g3=i;
l10:
  for(i=0;i<k;i++){ if(b[i]==':')b[i]=32; if(b[i]=='-')p=1; }
  if(g2)b[g2-1]=0;
  sscanf(b,"%d %d %lf",&i1,&i2,&x3);
  *rc=i1+i2/60.+x3/3600.;
  if(g2==0)goto l20;
  if(g3)b[g3-1]=0;
  i2=0; x3=0.; sscanf(&b[g2],"%d %d %lf",&i1,&i2,&x3);
  if(i1<0)i1=-i1;
  *dc=i1+i2/60.+x3/3600.;
  if(p)*dc=-*dc;
  if(g3)sscanf(&b[g3],"%lf",epoch);
l20: ;
}

sortd4(i1,i2,x,y,f1,f2,f3,f4,s1,s2,griz,n)
int n,*i1,*i2; double *x,*y; float *f1,*f2,*f3,*f4; short *s1,*s2;
short griz[nn][21];
{
  int i,j,k=2,l,ii,ifin;
  int    ii1,ii2;
  double xx,yy;
  float  ff1,ff2,ff3,ff4;
  short  ss1,ss2,g16[21];
  while(k<n)k*=2;
  k=(3*k)/4-1; if(n<k)k=n;
l20:
  k/=2;        ifin=n-k;
  for(ii=0;ii<ifin;ii++){
    i=ii;      j=i+k;
    if(y[i]<=y[j])continue;
    ii1=i1[j];     ii2=i2[j];
    xx = x[j];      yy= y[j]; 
    ff1=f1[j];     ff2=f2[j];    ff3=f3[j];    ff4=f4[j];
    ss1=s1[j];     ss2=s2[j];
    for(l=0;l<21;l++)g16[l]=griz[j][l];
l40:
    i1[j]=i1[i]; i2[j]=i2[i];
     x[j]= x[i];  y[j]= y[i];
    f1[j]=f1[i]; f2[j]=f2[i];  f3[j]=f3[i];  f4[j]=f4[i];
    s1[j]=s1[i]; s2[j]=s2[i];
    for(l=0;l<21;l++)griz[j][l]=griz[i][l];
    j=i;       i-=k;
    if(i<0)goto l60;
    if(y[i]>yy)goto l40;
l60:
    i1[j]=ii1;     i2[j]=ii2;
     x[j]=xx;       y[j]=yy;
    f1[j]=ff1;     f2[j]=ff2;    f3[j]=ff3;    f4[j]=ff4; 
    s1[j]=ss1;     s2[j]=ss2;
    for(l=0;l<21;l++)griz[j][l]=g16[l];
  }
  if(k>1)goto l20;
}
